// MyHtmlCtrl.h : Declaration of the CMyHtmlCtrl

#ifndef __MYHTMLCTRL_H_
#define __MYHTMLCTRL_H_

#include "resource.h"       // main symbols
#include <atlctl.h>


/////////////////////////////////////////////////////////////////////////////
// CMyHtmlCtrl
class ATL_NO_VTABLE CMyHtmlCtrl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IMyHtmlCtrl, &IID_IMyHtmlCtrl, &LIBID_MYHTMLCONTROLLib>,
	public IDispatchImpl<IMyHtmlCtrlUI, &IID_IMyHtmlCtrlUI, &LIBID_MYHTMLCONTROLLib>,
	public CComControl<CMyHtmlCtrl>,
	public IPersistStreamInitImpl<CMyHtmlCtrl>,
	public IOleControlImpl<CMyHtmlCtrl>,
	public IOleObjectImpl<CMyHtmlCtrl>,
	public IOleInPlaceActiveObjectImpl<CMyHtmlCtrl>,
	public IViewObjectExImpl<CMyHtmlCtrl>,
	public IOleInPlaceObjectWindowlessImpl<CMyHtmlCtrl>,
	public IPersistStorageImpl<CMyHtmlCtrl>,
	public ISpecifyPropertyPagesImpl<CMyHtmlCtrl>,
	public IQuickActivateImpl<CMyHtmlCtrl>,
	public IDataObjectImpl<CMyHtmlCtrl>,
	public IProvideClassInfo2Impl<&CLSID_MyHtmlCtrl, NULL, &LIBID_MYHTMLCONTROLLib>,
	public CComCoClass<CMyHtmlCtrl, &CLSID_MyHtmlCtrl>
{
public:
	CMyHtmlCtrl()
	{
		m_bWindowOnly = TRUE;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_MYHTMLCTRL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMyHtmlCtrl)
	COM_INTERFACE_ENTRY(IMyHtmlCtrl)
	COM_INTERFACE_ENTRY(IMyHtmlCtrlUI)
	COM_INTERFACE_ENTRY2(IDispatch, IMyHtmlCtrl)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CMyHtmlCtrl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CMyHtmlCtrl)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	CHAIN_MSG_MAP(CComControl<CMyHtmlCtrl>)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(0)

// IMyHtmlCtrl
public:

// IMyHtmlCtrlUI
public:
	// Example method called by the HTML to change the <BODY> background color
	STDMETHOD(OnClick)(IDispatch* pdispBody, VARIANT varColor)
	{
		CComQIPtr<IHTMLBodyElement> spBody(pdispBody);
		if (spBody != NULL)
			spBody->put_bgColor(varColor);
		return S_OK;
	}

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		CAxWindow wnd(m_hWnd);
		HRESULT hr = wnd.CreateControl(IDH_MYHTMLCTRL);
		if (SUCCEEDED(hr))
			hr = wnd.SetExternalDispatch(static_cast<IMyHtmlCtrlUI*>(this));
		if (SUCCEEDED(hr))
			hr = wnd.QueryControl(IID_IWebBrowser2, (void**)&m_spBrowser);
		return SUCCEEDED(hr) ? 0 : -1;
	}

	CComPtr<IWebBrowser2> m_spBrowser;
};

#endif //__MYHTMLCTRL_H_
